<?php
namespace Zeedhi\ReportWebService\Services;

/**
 * Throws the possible exceptions generatin the report.
 */
class Exception extends \Exception{

    /** @const integer Error code for when the given report name is not founded. */
    const REPORT_NOT_FOUND = 0;
    /** @const integer Error code for when there is a necessary property missing in the report generation. */
    const MISSING_PROPERTY = 1;

    /**
     * Exception throwed when there is no report with the given name.
     *
     * @return static The exception.
     */
    public static function reportNotFound() {
        return new self('Report not found', self::REPORT_NOT_FOUND);
    }

    /**
     * Exception throwed when there is a missing property on the metadata.
     *
     * @param string $propertyName The name of the missing property.
     *
     * @return static The exception.
     */
    public static function missingProperty($propertyName) {
        return new self("It's missing value for property {$propertyName} in report metadata.", self::MISSING_PROPERTY);
    }

}